#include<bits/stdc++.h>
using namespace std;

const int nmax=2e6+42,mod=1e9+7;

short first_seen_up[10][nmax];
short first_seen_down[10][nmax];

bool cmp(pair<int,int> a,pair<int,int> b)
{
    return a.first>b.first;
}
vector< pair<int,int> > my_merge(vector< vector<int> > inp,int cut)
{
    /*
    cout<<"my_merge "<<cut<<endl;
    cout<<"inp: "<<endl;
    for(auto p:inp)
    {
        for(auto q:p)cout<<q<<" ";cout<<endl;
    }
    cout<<"---"<<endl;
    */

    int m=inp[0].size();

    for(int b=0;b<10;b++)
        for(int j=0;j<m;j++)
        {
            first_seen_up[b][j]=-1;
            first_seen_down[b][j]=-1;
        }

    for(int j=0;j<m;j++)
    {
        int cur=0;

        for(int i=cut;i>=0;i--)
        {
            cur=cur|inp[i][j];

            for(int b=0;b<10;b++)
                if((cur&(1<<b))&&first_seen_up[b][j]==-1)first_seen_up[b][j]=i;
        }

        cur=0;

        for(int i=cut+1;i<inp.size();i++)
        {
            cur=cur|inp[i][j];

            for(int b=0;b<10;b++)
                if((cur&(1<<b))&&first_seen_down[b][j]==-1)first_seen_down[b][j]=i;
        }
    }

    unordered_map<int,int> cnt={};

    for(int j1=0;j1<m;j1++)
    {
        short seen_up[10];
        memset(seen_up,-1,sizeof(seen_up));

        short seen_down[10];
        memset(seen_down,-1,sizeof(seen_down));

        for(int j2=j1;j2<m;j2++)
        {
            for(int bit=0;bit<10;bit++)
            {
                if(first_seen_up[bit][j2]!=-1)
                {
                    if(seen_up[bit]==-1)seen_up[bit]=first_seen_up[bit][j2];
                    else seen_up[bit]=max(seen_up[bit],first_seen_up[bit][j2]);
                }
            }

            vector< pair<int,int> > LHS={};

            vector< pair<int,int> > help={};

            for(int bit=0;bit<10;bit++)
                if(seen_up[bit]!=-1)help.push_back({seen_up[bit],bit});

            sort(help.begin(),help.end(),cmp);

            int cur=0,prv=cut+1;

            for(int i=0;i<help.size();i++)
            {
                int j=i;

                while(j<help.size()&&help[i].first==help[j].first)
                {
                    cur=cur+(1<<help[j].second);

                    j++;
                }

                i=j-1;

                LHS.push_back({cur,prv-help[i].first});

                prv=help[i].first;
            }

            LHS.push_back({cur,prv});







            for(int bit=0;bit<10;bit++)
            {
                if(first_seen_down[bit][j2]!=-1)
                {
                    if(seen_down[bit]==-1)seen_down[bit]=first_seen_down[bit][j2];
                    else seen_down[bit]=min(seen_down[bit],first_seen_down[bit][j2]);
                }
            }

            vector< pair<int,int> > RHS={};

            help={};

            for(int bit=0;bit<10;bit++)
                if(seen_down[bit]!=-1)help.push_back({seen_down[bit],bit});

            sort(help.begin(),help.end());

            cur=0,prv=cut;

            for(int i=0;i<help.size();i++)
            {
                int j=i;

                while(j<help.size()&&help[i].first==help[j].first)
                {
                    cur=cur+(1<<help[j].second);

                    j++;
                }

                i=j-1;

                RHS.push_back({cur,help[i].first-prv});

                prv=help[i].first;
            }

            RHS.push_back({cur,inp.size()-1-prv});

            /*
            cout<<"j1= "<<j1<<" j2= "<<j2<<endl;
            cout<<"LHS: ";for(auto w:LHS)cout<<w.first<<" "<<w.second<<" , ";cout<<endl;
            cout<<"RHS: ";for(auto w:RHS)cout<<w.first<<" "<<w.second<<" , ";cout<<endl;
            */

            for(auto p:LHS)
                for(auto q:RHS)
                    cnt[p.first|q.first]=(cnt[p.first|q.first]+1LL*p.second*q.second)%mod;
        }
    }

    vector< pair<int,int> > ret={};
    for(auto w:cnt)ret.push_back(w);

    return ret;
}

vector< vector<int> > inp;

vector< pair<int,int> > gen(int x1,int x2,int y1,int y2)
{
    //cout<<"gen "<<x1<<" "<<x2<<" "<<y1<<" "<<y2<<endl;

    if(x1==x2&&y1==y2)return {{inp[x1][y1],1}};

    vector< pair<int,int> > LHS={},RHS={},help={};
    vector< vector<int> > inp_new={};

    if(x2-x1>=y2-y1)
    {
        int av=(x1+x2)/2;

        LHS=gen(x1,av,y1,y2);

        RHS=gen(av+1,x2,y1,y2);

        inp_new={};

        for(int i=x1;i<=x2;i++)
        {
            vector<int> me={};

            for(int j=y1;j<=y2;j++)
            {
                me.push_back(inp[i][j]);
            }
            inp_new.push_back(me);
        }

        help=my_merge(inp_new,av-x1);
    }
    else
    {
        int av=(y1+y2)/2;

        LHS=gen(x1,x2,y1,av);

        RHS=gen(x1,x2,av+1,y2);

        inp_new={};

        for(int j=y1;j<=y2;j++)
        {
            vector<int> me={};

            for(int i=x1;i<=x2;i++)
            {
                me.push_back(inp[i][j]);
            }
            inp_new.push_back(me);
        }

        help=my_merge(inp_new,av-y1);
    }

    unordered_map<int,int> cnt={};

    for(auto w:LHS)cnt[w.first]=(cnt[w.first]+w.second)%mod;

    for(auto w:RHS)cnt[w.first]=(cnt[w.first]+w.second)%mod;

    for(auto w:help)cnt[w.first]=(cnt[w.first]+w.second)%mod;

    vector< pair<int,int> > ret={};

    for(auto w:cnt)ret.push_back(w);

    /*
    cout<<"x1= "<<x1<<" y1= "<<y1<<" x2= "<<x2<<" y2= "<<y2<<endl;
    cout<<"ret= ";for(auto w:ret)cout<<w.first<<" "<<w.second<<"\t";cout<<endl;
    */

    return ret;
}
int solve(std::vector<int> P, int N, int M,
std::vector<std::vector<int>> A)
{
    inp=A;

    vector< pair<int,int> > help=gen(0,N-1,0,M-1);

    //for(auto w:help)cout<<w.first<<" "<<w.second<<" , ";cout<<endl;

    long long outp=0;

    for(auto w:help)
        outp=(outp+1LL*P[w.first]*w.second)%mod;

    return outp;
}
/*
vector< vector<int> > in;
int main()
{
    mt19937 rng(42);

    vector<int> p={};
    for(int i=0;i<1024;i++)p.push_back(rng()%100+1);

    int n,m;

    scanf("%i%i",&n,&m);

    for(int i=0;i<n;i++)
    {
        vector<int> me={};

        for(int j=0;j<m;j++)
        {
            int cur;
            scanf("%i",&cur);

            me.push_back(cur);
        }

        in.push_back(me);
    }

    printf("%i\n",solve(p,n,m,in));

    return 0;
}
*/
