#include<bits/stdc++.h>
using namespace std;

const int nmax=1e5+42;

vector<int> adj[nmax];

vector<int> adj_g[nmax];

int dist[3000][3000];

int n;

int other;

int outp[nmax];

void dfs(int node,int par,int d,int root)
{
    dist[root][node]=d;

    for(auto w:adj[node])
        if(w!=par)dfs(w,node,d+1,root);
}

int NODE_NOW,COLOUR;
int VALID;

bool possible(int wanted,int is)
{
    if(wanted>is)return 0;

    if((is-wanted)%2==1)return 0;

    return 1;
}
void dfs_g(int node,int par,int d)
{
    if(VALID==0)return;

    if(outp[node]!=-1)
    {
        if(possible(dist[outp[node]][COLOUR],d)==0)
        {
            //cout<<node<<" wrong "<<dist[outp[node]][COLOUR]<<" "<<d<<endl;

            VALID=0;
            return;
        }
    }

    for(auto w:adj_g[node])
        if(w!=par)dfs_g(w,node,d+1);
}
bool check(int node,int colour)
{
    NODE_NOW=node;
    COLOUR=colour;

    VALID=1;

    //cout<<"testing "<<node<<" "<<colour<<endl;

    dfs_g(node,node,0);

    return VALID;
}

int parent[nmax];
int root(int node)
{
    if(node==parent[node])return node;
    parent[node]=root(parent[node]);
    return parent[node];
}
std::vector<int> solve(int N, int V, int E, std::vector<int> A,
 std::vector<int> B, std::vector<int> X, std::vector<int> Y)
{
    n=N;

    other=V;

    for(int i=0;i<other;i++)parent[i]=i;

    for(int i=0;i<n;i++)adj[i]={};

    for(int i=0;i<other;i++)outp[i]=0;

    for(int i=0;i<n;i++)outp[i]=i;

    for(int i=0;i<other;i++)adj_g[i]={};

    for(int i=0;i<A.size();i++)
    {
        int u=A[i];
        int v=B[i];

        adj[u].push_back(v);
        adj[v].push_back(u);
    }

    for(int i=0;i<X.size();i++)
    {
        int u=X[i];
        int v=Y[i];

        assert(root(u)!=root(v));

        parent[root(u)]=root(v);

        adj_g[u].push_back(v);
        adj_g[v].push_back(u);
    }
    /*
    for(int i=0;i<n;i++)
    {
        dfs(i,i,0,i);
    }

    for(int i=n;i<other;i++)
    {
        for(int j=0;j<n&&outp[i]==-1;j++)
            if(check(i,j))outp[i]=j;
    }
    */

    vector<int> ret={};

    for(int i=0;i<other;i++)ret.push_back(outp[i]);

    return ret;
}
/*
int main()
{
    for(auto w:solve(2, 4, 2, {0}, {1}, {2, 3}, {0, 1}))cout<<w<<" ";cout<<endl;
    for(auto w:solve(4, 5, 3, {0, 0, 0}, {1, 2, 3}, {1, 2, 3}, {4, 4, 4}))cout<<w<<" ";cout<<endl;
    for(auto w:solve(3, 4, 2, {0, 1}, {1, 2}, {3, 3}, {0, 2}))cout<<w<<" ";cout<<endl;

    return 0;
}
*/
