#include <vector>
using namespace std;

const int MOD = 1000000007;

vector<vector<vector<short int>>> row, col;

int solve(vector<int> P, int N, int M, vector<vector<int>> A)
{
    //row.resize(N);
    /*for (int i = 0; i < N; ++ i)
    {
        row[i].resize(M);
        for (int j = 0; j < M; ++ j)
        {
            row[i][j].resize(10);
            for (int k = 0; k < 10; ++ k)
            {
                if (j + k == M) break;
                else if (k == 0) row[i][j][k] = A[i][j];
                else row[i][j][k] = row[i][j][k - 1] | A[i][j + k];
            }
        }
    }*/

    col.resize(N);
    for (int i = 0; i < N; ++ i)
    {
        col[i].resize(M);
        for (int j = 0; j < M; ++ j)
        {
            col[i][j].resize(25);
            for (int k = 0; k < 25; ++ k)
            {
                if (i + k == N) break;
                else if (k == 0) col[i][j][k] = A[i][j];
                else col[i][j][k] = col[i][j][k - 1] | A[i + k][j];
            }
        }
    }

    long long ans = 0;

    for (int i = 0; i < N; ++ i)
    {
        for (int j = 0; j < M; ++ j)
        {
            int cnt = 0;

            for (int h = 1; h < N - i; ++ h)
            {
                int OR = 0, step = 0;
                for (int w = 1; w < M - j; ++ w)
                {
                    OR |= col[i][j + w - 1][h - 1];
                    cnt++;
                    ans = (ans + P[OR]) % MOD;
                    if (OR == 1023)
                    {
                        step = w;
                        break;
                    }
                }
                if (step == 1) break;
            }

            long long total = 1ll * (N - i) * (M - j);
            total -= cnt;
            ans = (ans + total * P[1023]) % MOD;
        }
    }

    return ans;
}
