#include <vector>
#include <queue>
using namespace std;

const int MAXN = 100005;

int n, v, e;
vector<int> g[MAXN];
vector<int> t[MAXN];
vector<int> c, order;

bool exit = 0;

//void Rec(int x = 0)
//{
//    if (x == order.size())
//    {
//        exit = true;
//        return;
//    }
//}

void Order()
{
    bool vis[MAXN];
    for (int i = 0; i < v; ++ i) vis[i] = 0;
    queue<int> q;
    for (int i = 0; i < n; ++ i) q.push(i);

    while (!q.empty())
    {
        int u = q.front();
        q.pop();
        for (int i = 0; i < g[u].size(); ++ i)
        {
            int adj = g[u][i];
            if (vis[adj] == 0)
            {
                if (c[u] == 0) c[adj] = 1;
                else c[adj] = 0;

                vis[adj] = 1;
                order.push_back(adj);
                q.push(adj);
            }
        }
    }

    for (int i = n; i < v; ++ i)
    {
        if (vis[i] == 0)
        {
            q.push(i);
            c[i] = 0;
            order.push_back(i);
            while (!q.empty())
            {
                int u = q.front();
                q.pop();
                for (int i = 0; i < g[u].size(); ++ i)
                {
                    int adj = g[u][i];
                    if (vis[adj] == 0)
                    {
                        if (c[u] == 0) c[adj] = 1;
                        else c[adj] = 0;
                        vis[adj] = 1;
                        order.push_back(adj);
                        q.push(adj);
                    }
                }
            }
        }
    }
}

vector<int> solve(int N, int V, int E, vector<int> A, vector<int> B, vector<int> X, vector<int> Y)
{
    n = N;
    v = V;
    e = E;
    for (int i = 0; i < e; ++ i)
    {
        g[X[i]].push_back(Y[i]);
        g[Y[i]].push_back(X[i]);
    }
    for (int i = 0; i < n - 1; ++ i)
    {
        t[A[i]].push_back(B[i]);
        t[B[i]].push_back(A[i]);
    }

    c.resize(v);
    for (int i = 0; i < n; ++ i) c[i] = i;
    for (int i = n; i < v; ++ i) c[i] = -1;

    Order();

    // Rec();

    // prepare for next call

    for (int i = 0; i < n; ++ i)
    {
        t[i].clear();
    }
    for (int i = 0; i < v; ++ i)
    {
        g[i].clear();
    }

    return c;
}
