#include <iostream>
#include <cstring>
#include <vector>
#include <bitset>

using namespace std;

const int MAXN = 1e6 + 5;
const long long mod = 1e9 + 7;

int c[MAXN];

int string2Int(const string &s)
{
    int x = 0;
    for(char c: s) x = x*2 + (c - '0');

    return x;
}

int read()
{
    string str;
    cin >> str;

    return string2Int(str);
}

int main()
{
    int l = read();
    int r = read();

    c[0] = 0;
    c[1] = 1;
    c[2] = 2;
    c[3] = 3;
    for(int x = 1;x<=r;x++)
    {
        if(x>3)
        {
            switch(x%4)
            {
            case 0:
                c[x] = 1 + c[x/2];
                break;
            case 1:
                c[x] = 2 + c[(x-1)/2];
                break;
            case 2:
                c[x] = 1 + c[x/2];
                break;
            case 3:
                c[x] = 2 + c[(x+1)/2];
                break;
            }
        }
    }


    long long sum = 0;
    for(int i = l+1;i<=r;i++)
        sum = (sum + c[i])%mod;

    cout << sum << '\n';
}
//11765 24918
