#include<bits/stdc++.h>
using namespace std;

const int nmax=2e6+42,mod=1e9+7;

int first_seen_up[10][2000];
int first_seen_down[10][2000];

int CNT_ALL[nmax];

void add(int pos,int val)
{
    CNT_ALL[pos]=CNT_ALL[pos]+val;

    if(CNT_ALL[pos]>=mod)CNT_ALL[pos]=CNT_ALL[pos]-mod;
}
bool cmp(pair<int,int> a,pair<int,int> b)
{
    return a.first>b.first;
}

pair<int,int> help[20];
int pointer_help=0;

pair<int,int> LHS[20];
int pointer_LHS=0;

pair<int,int> RHS[20];
int pointer_RHS=0;

void my_merge(vector< vector<int> > inp,int cut)
{
    /*
    cout<<"my_merge "<<cut<<endl;
    cout<<"inp: "<<endl;
    for(auto p:inp)
    {
        for(auto q:p)cout<<q<<" ";cout<<endl;
    }
    cout<<"---"<<endl;
    */

    int m=inp[0].size();

    for(int b=0;b<10;b++)
        for(int j=0;j<m;j++)
        {
            first_seen_up[b][j]=-1;
            first_seen_down[b][j]=-1;
        }

    for(int j=0;j<m;j++)
    {
        int cur=0;

        for(int i=cut;i>=0;i--)
        {
            cur=cur|inp[i][j];

            for(int b=0;b<10;b++)
                if((cur&(1<<b))&&first_seen_up[b][j]==-1)first_seen_up[b][j]=i;
        }

        cur=0;

        for(int i=cut+1;i<inp.size();i++)
        {
            cur=cur|inp[i][j];

            for(int b=0;b<10;b++)
                if((cur&(1<<b))&&first_seen_down[b][j]==-1)first_seen_down[b][j]=i;
        }
    }

    for(int j1=0;j1<m;j1++)
    {
        int seen_up[10];
        memset(seen_up,-1,sizeof(seen_up));

        int seen_down[10];
        memset(seen_down,-1,sizeof(seen_down));

        for(int j2=j1;j2<m;j2++)
        {
            for(int bit=0;bit<10;bit++)
            {
                if(first_seen_up[bit][j2]!=-1)
                {
                    if(seen_up[bit]==-1)seen_up[bit]=first_seen_up[bit][j2];
                    else seen_up[bit]=max(seen_up[bit],first_seen_up[bit][j2]);
                }
            }

            pointer_help=0;

            for(int bit=0;bit<10;bit++)
                if(seen_up[bit]!=-1)
                {
                    help[pointer_help++]={seen_up[bit],bit};
                }

            sort(help,help+pointer_help,cmp);

            //cout<<"help_lhs: ";for(auto w:help)cout<<w.first<<" "<<w.second<<"\t";cout<<endl;

            int cur=0,prv=cut;

            pointer_LHS=0;

            for(int i=0;i<pointer_help;i++)
            {
                //cout<<pointer_LHS<<" "<<pointer_help<<" "<<i<<endl;

                if(prv!=help[i].first)LHS[pointer_LHS++]={cur,prv-help[i].first};

                prv=help[i].first;

                cur=cur+(1<<help[i].second);
            }

            LHS[pointer_LHS++]={cur,prv+1};

            //cout<<"LHS: ";for(int i=0;i<pointer_LHS;i++)cout<<LHS[i].first<<" "<<LHS[i].second<<" ";cout<<endl;

            for(int bit=0;bit<10;bit++)
            {
                if(first_seen_down[bit][j2]!=-1)
                {
                    if(seen_down[bit]==-1)seen_down[bit]=first_seen_down[bit][j2];
                    else seen_down[bit]=min(seen_down[bit],first_seen_down[bit][j2]);
                }
            }

            pointer_help=0;

            for(int bit=0;bit<10;bit++)
                if(seen_down[bit]!=-1)help[pointer_help++]={seen_down[bit],bit};

            sort(help,help+pointer_help);

            cur=0,prv=cut+1;

            pointer_RHS=0;

            for(int i=0;i<pointer_help;i++)
            {
                if(prv!=help[i].first)RHS[pointer_RHS++]={cur,help[i].first-prv};

                prv=help[i].first;

                cur=cur+(1<<help[i].second);
            }

            RHS[pointer_RHS++]={cur,inp.size()-prv};

            /*
            cout<<"j1= "<<j1<<" j2= "<<j2<<endl;
            cout<<"LHS: ";for(auto w:LHS)cout<<w.first<<" "<<w.second<<" , ";cout<<endl;
            cout<<"RHS: ";for(auto w:RHS)cout<<w.first<<" "<<w.second<<" , ";cout<<endl;
            */

            for(int i=0;i<pointer_LHS;i++)
                for(int j=0;j<pointer_RHS;j++)
                    add(LHS[i].first|RHS[j].first,1LL*LHS[i].second*RHS[j].second%mod);
        }
    }
}

vector< vector<int> > inp;

void gen(int x1,int x2,int y1,int y2)
{
    //cout<<"gen "<<x1<<" "<<x2<<" "<<y1<<" "<<y2<<endl;

    if(x1==x2&&y1==y2)
    {
        add(inp[x1][y1],1);
        return;
    }

    vector< vector<int> > inp_new={};

    if(x2-x1>=y2-y1)
    {
        int av=(x1+x2)/2;

        gen(x1,av,y1,y2);

        gen(av+1,x2,y1,y2);

        inp_new={};

        for(int i=x1;i<=x2;i++)
        {
            vector<int> me={};

            for(int j=y1;j<=y2;j++)
            {
                me.push_back(inp[i][j]);
            }
            inp_new.push_back(me);
        }

        my_merge(inp_new,av-x1);
    }
    else
    {
        int av=(y1+y2)/2;

        gen(x1,x2,y1,av);

        gen(x1,x2,av+1,y2);

        inp_new={};

        for(int j=y1;j<=y2;j++)
        {
            vector<int> me={};

            for(int i=x1;i<=x2;i++)
            {
                me.push_back(inp[i][j]);
            }
            inp_new.push_back(me);
        }

        my_merge(inp_new,av-y1);
    }
}
int solve(std::vector<int> P, int N, int M,
std::vector<std::vector<int>> A)
{
    inp=A;

    gen(0,N-1,0,M-1);

    //for(auto w:help)cout<<w.first<<" "<<w.second<<" , ";cout<<endl;

    //cout<<CNT_ALL[0]<<" , "<<1LL*M*(M+1)/2%mod<<endl;

    long long outp=0;

    for(int i=0;i<P.size();i++)
        outp=(outp+1LL*P[i]*CNT_ALL[i])%mod;

    return outp;
}
/*
vector< vector<int> > in;
int main()
{
    int inf=1e9+1;

    mt19937 rng(42);

    vector<int> p={};
    for(int i=0;i<1024;i++)p.push_back(rng()%inf);

    int n,m;

    //scanf("%i%i",&n,&m);
    n=1;
    m=1e6;

    for(int i=0;i<n;i++)
    {
        vector<int> me={};

        for(int j=0;j<m;j++)
        {
            int cur;
            //scanf("%i",&cur);
            //cur=rng()%1024;
            cur=0;

            me.push_back(cur);
        }

        in.push_back(me);
    }

    printf("%i\n",solve(p,n,m,in));

    cout<<1LL*m*(m+1)/2%mod*p[0]%mod<<endl;

    return 0;
}
*/
