#include<bits/stdc++.h>
using namespace std;

const int nmax=1e6+42,mod=1e9+7;

string inp;

int ask(long long i)
{
    if(i==0||i==3)return i;

    if(i%2==0)return 1+ask(i/2);

    if(i%4==1)return 1+ask(i-1);

    return 1+ask(i+1);
}

int sum(long long from,long long val)
{
    long long ret=0;

    for(long long i=from;i<=val;i++)ret=(ret+ask(i))%mod;

    return ret;
}

map<long long,int> mp;

int fast(long long n)
{
    if(n<=4)
    {
        int ret=0;

        for(int i=1;i<=n;i++)
        {
            ret=ret+ask(i);
        }

        return ret;
    }

    if(mp.count(n))return mp[n];

    long long even=n/2;

    long long ret=even+fast(even);

    //cout<<"step 1: "<<ret<<endl;

    long long cnt_4_1=(n-1)/4;

    ret=ret+cnt_4_1*3+1+fast(cnt_4_1);

    //cout<<"step 2: "<<ret<<endl;

    long long cnt_4_3=(n-3)/4;

    ret=ret+cnt_4_3*3+2+fast(cnt_4_3+1);

    //cout<<"step 3: "<<ret<<endl;

    mp[n]=ret;

    return ret;
}

int f(string cur)
{
    inp=cur;

    long long val=0;

    for(auto p:cur)val=val*2+p-'0';

    return sum(1,val);
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie();
    cout.tie();
    string l,r;

    cin>>l>>r;

    int p=f(l);

    int q=f(r);

    cout<<(q-p+mod)%mod<<endl;

    return 0;
}
