#include <iostream>
using namespace std;

const int MAXN = 1003;
const int MOD = 1000000007;

int n, c[MAXN];

void Calc()
{
    c[0] = 0;
    c[1] = 1;
    c[2] = 2; c[4] = 3;
    c[3] = 3; c[6] = 4;
    for (int i = 4; i <= n; ++ i)
    {
        if (i % 2 == 1)
        {
            if (((i - 1) / 2) % 2 == 1) c[i] = 1 + c[i + 1];
            else c[i] = 1 + c[i - 1];
        }
        c[i * 2] = 1 + c[i];
    }
}

void Print()
{
    for (int i = 1; i <= n; ++ i)
    {
        if (i % 2 == 1 and (i - 1) / 2 % 2 == 1)
        {
            if (c[i] != c[i - 1] + 1) cout << i << endl;
        }
    }

    for (int i = 1; i <= n; ++ i)
    {
        cout << i % 10 << ' ';
    }
    cout << endl;
    for (int i = 1; i <= n; ++ i)
    {
        cout << c[i] << ' ';
    }
}

int C(string s)
{
    int cnt = 0;
    while (true)
    {
        if (s == "10") cnt += 2;
        if (s == "11") cnt += 3;
        if (s == "01") cnt += 1;
        if (s == "00") cnt += 0;
        if (s.size() == 2) break;

        if (s.back() == '0') {cnt++;s.pop_back();}
        else if (s.back() == '1')
        {
            if (s[s.size() - 2] == '1')
            {
                cnt++;
                int idx = s.size() - 1;
                while (idx != -1 and s[idx] == '1')
                {
                    s[idx--] = '0';
                }
                if (idx == -1) s = "1" + s;
                else s[idx] = '1';
            }
            else {cnt++; s[s.size() - 1] = '0';}
        }
    }

    return cnt;
}

int main()
{
    string l, r;
    cin >> l >> r;

    int ans = 0;
    while (l != r)
    {
        int idx = l.size() - 1;
        while (idx != -1 and l[idx] == '1')
        {
            l[idx--] = '0';
        }
        if (idx == -1) l = "1" + l;
        else l[idx] = '1';

        ans += C(l);
    }

    cout << ans << endl;
    return 0;
}
